import { DoCheck, EventEmitter, IterableDiffers, OnChanges, SimpleChange } from '@angular/core';
import { ReplaySubject } from 'rxjs';
import * as i0 from "@angular/core";
export declare type SortOrder = 'asc' | 'desc';
export interface SortEvent {
    sortBy: string | string[];
    sortOrder: SortOrder;
}
export interface PageEvent {
    activePage: number;
    rowsOnPage: number;
    dataLength: number;
}
export interface DataEvent {
    length: number;
}
export declare class AngularDatatableDirective implements OnChanges, DoCheck {
    private differs;
    private diff;
    inputData: any[];
    sortBy: string | string[];
    sortOrder: SortOrder;
    sortByChange: EventEmitter<string | string[]>;
    sortOrderChange: EventEmitter<string>;
    rowsOnPage: number;
    activePage: number;
    private mustRecalculateData;
    data: any[];
    onSortChange: ReplaySubject<SortEvent>;
    onPageChange: EventEmitter<PageEvent>;
    constructor(differs: IterableDiffers);
    getSort(): SortEvent;
    setSort(sortBy: string | string[], sortOrder: string): void;
    getPage(): PageEvent;
    setPage(activePage: number, rowsOnPage: number): void;
    private calculateNewActivePage;
    private recalculatePage;
    ngOnChanges(changes: {
        [key: string]: SimpleChange;
    }): any;
    ngDoCheck(): any;
    private fillData;
    private caseInsensitiveIteratee;
    static ɵfac: i0.ɵɵFactoryDeclaration<AngularDatatableDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AngularDatatableDirective, "table[mfData]", ["mfDataTable"], { "inputData": "mfData"; "sortBy": "mfSortBy"; "sortOrder": "mfSortOrder"; "rowsOnPage": "mfRowsOnPage"; "activePage": "mfActivePage"; }, { "sortByChange": "mfSortByChange"; "sortOrderChange": "mfSortOrderChange"; }, never>;
}
